#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_StarLotteryVIPChipEachDayLimitCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_StarLotteryVIPChipEachDayLimitCFG> M_StarLotteryVIPChipEachDayLimitCFG::msSingleton(nullptr);

int M_StarLotteryVIPChipEachDayLimitCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_StarLotteryVIPChipEachDayLimitCFGData* M_StarLotteryVIPChipEachDayLimitCFG::GetData(int CreateDays)
{
	auto it = mMapData.find(CreateDays);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_StarLotteryVIPChipEachDayLimitCFGData>& M_StarLotteryVIPChipEachDayLimitCFG::GetMapData()
{
	return mMapData;
}

void M_StarLotteryVIPChipEachDayLimitCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_StarLotteryVIPChipEachDayLimitCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_StarLotteryVIPChipEachDayLimitCFGData data;
		data.mCreateDays = element->IntAttribute("CreateDays");
		data.mGetMaxChip = element->IntAttribute("GetMaxChip");
		if (mMapData.find(data.mCreateDays) != mMapData.end())std::cout <<"data refind:" << data.mCreateDays << std::endl;
		assert(mMapData.find(data.mCreateDays) == mMapData.end());
		mMapData.insert(std::make_pair(data.mCreateDays, data));
		element = element->NextSiblingElement();
	}
}

void M_StarLotteryVIPChipEachDayLimitCFG::Load()
{
	Load("../Config/M_StarLotteryVIPChipEachDayLimitCFG.xml");
}

M_StarLotteryVIPChipEachDayLimitCFG* M_StarLotteryVIPChipEachDayLimitCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_StarLotteryVIPChipEachDayLimitCFG());
	}
	return msSingleton.get();
}
